/* Plugin generated by AMXX-Studio */

#include <amxmodx>
#include <amxmisc>
#include <hamsandwich>
#include <fakemeta_util>
#include <cstrike>

#define PLUGIN "Thompson 1928 SMG"
#define VERSION "1.0"
#define AUTHOR "ezio_auditore"

#define m_pPlayer 41

new szModels[3][] = {
	"models/thompson/p_thomp.mdl",
	"models/thompson/v_thomp.mdl",
	"models/thompson/w_thomp.mdl"
}

new szCvars[4][] = {
	"amx_thomp_cost",
	"amx_thomp_bpammo",
	"amx_thomp_buyzone",
	"amx_thomp_dam_mult"
}

new g_Cost, g_BpAmmo, g_Bzone, g_DamMult
new g_HasThomp[33] , allowed[33]

public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	register_clcmd("say /thomp", "clReqThomp")
	register_concmd("thomp", "clReqThomp")
	
	g_Cost		= register_cvar(szCvars[0], "5000")
	g_BpAmmo	= register_cvar(szCvars[1], "100")
	g_Bzone		= register_cvar(szCvars[2], "0")
	g_DamMult	= register_cvar(szCvars[3], "3")
	
	RegisterHam(Ham_Item_Deploy, "weapon_mp5navy", "fwd_WeapDeployPost", 1)
	RegisterHam(Ham_TakeDamage, "player", "fwd_TakeDamage")
	RegisterHam(Ham_Touch, "weaponbox", "fwd_Touch")
	
	register_forward(FM_SetModel, "fwd_SetModel")
}

public plugin_precache()
{
	for (new i = 0 ; i < sizeof szModels ; i++)
	{
		engfunc(EngFunc_PrecacheModel, szModels[i])
	}
}

public clReqThomp(id)
{
	new iMoney = cs_get_user_money(id)
	if (!is_user_alive(id))
	{
		client_print(id, print_center, "You Must Be Alive")
		return PLUGIN_HANDLED
	}
	if (get_pcvar_num(g_Bzone) && !cs_get_user_buyzone(id))
	{
		client_print(id, print_center, "You Must Be In A Buyzone")
		return PLUGIN_HANDLED
	}
	if (iMoney < get_pcvar_num(g_Cost))
	{
		client_print(id, print_center, "Not Enough Money")
		return PLUGIN_HANDLED
	}
	if (g_HasThomp[id])
	{
		client_print(id, print_center, "You Already Own That Weapon")
		return PLUGIN_HANDLED
	}
	
	give_thomp(id)
	client_print(id, print_center, "You Bought Thompson 1928 SMG")
	cs_set_user_money(id, iMoney - get_pcvar_num(g_Cost), 1)
	
	return PLUGIN_HANDLED
}

public fwd_WeapDeployPost(iEnt)
{
	new id = get_pdata_cbase(iEnt, m_pPlayer, 5)
	if (g_HasThomp[id])
	{
		changemodels(id)
	}
}

public fwd_TakeDamage(victim, inflictor, attacker, Float:damage, damagebits)
{
	if (g_HasThomp[attacker] && get_user_weapon(attacker) == CSW_MP5NAVY)
	{
		SetHamParamFloat(4, damage * get_pcvar_num(g_DamMult))
	}
}

public fwd_SetModel(iEnt, const model[])
{
	if (!pev_valid(iEnt))
		return FMRES_IGNORED
	
	new owner = pev(iEnt, pev_owner)
	
	if (!equal(model, "models/w_mp5.mdl"))
		return FMRES_IGNORED
		
	new szClassName[33]
	pev(iEnt, pev_classname, szClassName, charsmax(szClassName))
	
	if (equal(szClassName, "weaponbox"))
	{
		g_HasThomp[owner] = false
		engfunc(EngFunc_SetModel, iEnt, szModels[2])
		set_task(0.1, "touchfix", owner)
		return FMRES_SUPERCEDE
	}
	
	return FMRES_IGNORED
}

public fwd_Touch(iEnt, id)
{
	new szModelName[33]
	pev(iEnt, pev_model, szModelName, charsmax(szModelName))
	
	if (equal(szModelName, szModels[2]) && allowed[id])
	{
		if (!g_HasThomp[id] && !user_has_weapon(id, CSW_MP5NAVY))
		{
			give_thomp(id)
			engfunc(EngFunc_RemoveEntity, iEnt)
		}
	}
}

stock give_thomp(index)
{
	fm_give_item(index, "weapon_mp5navy")
	cs_set_user_bpammo(index, CSW_MP5NAVY, get_pcvar_num(g_BpAmmo))
	g_HasThomp[index] = true
	allowed[index] = false
	changemodels(index)
}

stock changemodels(index)
{
	set_pev(index, pev_weaponmodel2, szModels[0])
	set_pev(index, pev_viewmodel2, szModels[1])
}

public touchfix(id)
{
	allowed[id] = true
}

public client_putinserver(id)
{
	allowed[id] = true
	g_HasThomp[id] = false
}

public client_disconnect(id)
{
	allowed[id] = false
	g_HasThomp[id] = false
}
